#!/usr/bin/env python
# -*- coding: UTF8 -*-
import os, sys

try:
	import cPickle
except:
	print "cpickle not found"
	sys.exit(1)

try:
	import gtk
	import gobject
	import osso
	import hildon
  	import datetime
  	import xmlrpclib
	import base64
	import time
except:
	sys.exit(1)

try:
	import wordpresslib
except:
	print "wordpresslib required"
	sys.exit(1)

#try:
#	import htmltextview
#except:
#	print "htmltextview required"
#	sys.exit(1)

import thread
osso_c = osso.Context("maemo_wordpy", "0.4", False)
osso_hlp = osso.Help(osso_c)
# Columns for ListStore for Categories
(COLUMN_FIXED, COLUMN_DESCRIPTION) = range(2)
# Create lists
data=[]
cats=[]
idfromcat=[]

gtk.gdk.threads_init()

class Wordpy(hildon.Program):
	def __init__(self):
		hildon.Program.__init__(self)

		#Create the main window
		self.wndMain = hildon.Window()
		self.wndMain.set_default_size(800, 480)
		self.wndMain.connect("key-press-event", self.on_key_press)
		self.wndMain.connect("window-state-event", self.on_window_state_change)
		self.wndMain.connect("destroy", self.quit)
		self.window_in_fullscreen = False 		

		self.wndMain.show()

		self.dat_file = os.path.join(sys.path[0], "/home/user/.maemowordpy/blog.dat")
		self.BlogSettings = WordPressBlogSettings(self.dat_file)

## Create menu       
		self.menubar = gtk.Menu()
		for child in self.menubar.get_children():
			child.reparent(menu)
		self.wndMain.set_menu(self.menubar)
		self.menubar.show()

		self.menu_exit = gtk.ImageMenuItem("Exit")		
		exit_img = gtk.image_new_from_stock(gtk.STOCK_QUIT, gtk.ICON_SIZE_MENU)
		self.menu_exit.set_image(exit_img)
		self.menu_exit.show()
		self.menu_exit.connect("activate", self.quit)

# Submenu File
		self.submenu_file=gtk.Menu()
		self.submenu_file.show()
		self.menu_file=gtk.MenuItem("File")
		self.menu_file.show()
		self.menu_file.set_submenu(self.submenu_file)

		self.newmenu=gtk.ImageMenuItem("New post") 
		new_img = gtk.image_new_from_stock(gtk.STOCK_NEW, gtk.ICON_SIZE_MENU)
		self.newmenu.set_image(new_img)
		self.newmenu.show()
		self.newmenu.connect("activate",self.on_new_post)

		self.openmenu=gtk.ImageMenuItem("Open post")
		open_img = gtk.image_new_from_stock(gtk.STOCK_OPEN, gtk.ICON_SIZE_MENU)
		self.openmenu.set_image(open_img)
		self.openmenu.show()
		self.openmenu.connect("activate",self.on_open_post)

		self.savemenu=gtk.ImageMenuItem("Save post")
		save_img = gtk.image_new_from_stock(gtk.STOCK_SAVE, gtk.ICON_SIZE_MENU)
		self.savemenu.set_image(save_img)
		self.savemenu.show()
		self.savemenu.connect("activate",self.on_save_post)

		self.submenu_file.append(self.newmenu)
		self.submenu_file.append(self.openmenu)
		self.submenu_file.append(self.savemenu)

# Submenu Edit
		self.submenu_edit=gtk.Menu()
		self.submenu_edit.show()
		self.menu_edit=gtk.MenuItem("Edit")
		self.menu_edit.show()
		self.menu_edit.set_submenu(self.submenu_edit)

		self.cutmenu=gtk.ImageMenuItem("Cut")
		cut_img = gtk.image_new_from_stock(gtk.STOCK_CUT, gtk.ICON_SIZE_MENU)
		self.cutmenu.set_image(cut_img)
		self.cutmenu.show()
		self.cutmenu.connect("activate",self.on_cut)

		self.copymenu=gtk.ImageMenuItem("Copy")
		copy_img = gtk.image_new_from_stock(gtk.STOCK_COPY, gtk.ICON_SIZE_MENU)
		self.copymenu.set_image(copy_img)
		self.copymenu.show()
		self.copymenu.connect("activate",self.on_copy)

		self.pastemenu=gtk.ImageMenuItem("Paste")
		paste_img = gtk.image_new_from_stock(gtk.STOCK_PASTE, gtk.ICON_SIZE_MENU)
		self.pastemenu.set_image(paste_img)
		self.pastemenu.show()
		self.pastemenu.connect("activate",self.on_paste)

		self.submenu_edit.append(self.cutmenu)
		self.submenu_edit.append(self.copymenu)
		self.submenu_edit.append(self.pastemenu)

# Submenu Tags
		self.submenu_tags=gtk.Menu()
		self.submenu_tags.show()
		self.menu_tags=gtk.MenuItem("Tags")
		self.menu_tags.show()
		self.menu_tags.set_submenu(self.submenu_tags)

		self.submenu_text=gtk.Menu()
		self.submenu_text.show()
		self.textmenu=gtk.MenuItem("Text")
		self.textmenu.show()
		self.textmenu.set_submenu(self.submenu_text)

		self.boldmenu=gtk.MenuItem("Bold")
		self.boldmenu.show()
		self.boldmenu.connect("activate",self.on_btnBold_clicked)

		self.italicmenu=gtk.MenuItem("Italic")
		self.italicmenu.show()
		self.italicmenu.connect("activate",self.on_btnItalic_clicked)

		self.blocmenu=gtk.MenuItem("Blockquote")
		self.blocmenu.show()
		self.blocmenu.connect("activate",self.on_btnBlockQuote_clicked)

		self.insmenu=gtk.MenuItem("<ins>")
		self.insmenu.show()
		self.insmenu.connect("activate",self.on_btnIns_clicked)

		self.delmenu=gtk.MenuItem("<del>")
		self.delmenu.show()
		self.delmenu.connect("activate",self.on_btnDel_clicked)

		self.codemenu=gtk.MenuItem("Code")
		self.codemenu.show()
		self.codemenu.connect("activate",self.on_btnCode_clicked)

		self.submenu_text.append(self.boldmenu)
		self.submenu_text.append(self.italicmenu)
		self.submenu_text.append(self.blocmenu)
		self.submenu_text.append(self.insmenu)
		self.submenu_text.append(self.delmenu)
		self.submenu_text.append(self.codemenu)
		
		self.submenu_font=gtk.Menu()
		self.submenu_font.show()
		self.fontmenu=gtk.MenuItem("Font")
		self.fontmenu.show()
		self.fontmenu.set_submenu(self.submenu_font)

		self.color_textmenu=gtk.MenuItem("Color Font")
		self.color_textmenu.show()
		self.color_textmenu.connect("activate",self.on_text_color_clicked)

		self.color_bgmenu=gtk.MenuItem("Color Background")
		self.color_bgmenu.show()
		self.color_bgmenu.connect("activate",self.on_bg_color_clicked)

		self.font_sizemenu=gtk.MenuItem("Font Size")
		self.font_sizemenu.show()
		self.font_sizemenu.connect("activate",self.on_size_font_clicked)

		self.submenu_font.append(self.color_textmenu)
		self.submenu_font.append(self.color_bgmenu)
		self.submenu_font.append(self.font_sizemenu)
		
		self.submenu_align=gtk.Menu()
		self.submenu_align.show()
		self.alignmenu=gtk.MenuItem("Align")
		self.alignmenu.show()
		self.alignmenu.set_submenu(self.submenu_align)

		self.leftmenu=gtk.MenuItem("Left")
		self.leftmenu.show()
		self.leftmenu.connect("activate",self.on_btnleft_clicked)

		self.centermenu=gtk.MenuItem("Center")
		self.centermenu.show()
		self.centermenu.connect("activate",self.on_btncenter_clicked)

		self.rightmenu=gtk.MenuItem("Right")
		self.rightmenu.show()
		self.rightmenu.connect("activate",self.on_btnright_clicked)

		self.justifymenu=gtk.MenuItem("Justify")
		self.justifymenu.show()
		self.justifymenu.connect("activate",self.on_btnjustify_clicked)

		self.submenu_align.append(self.leftmenu)
		self.submenu_align.append(self.centermenu)
		self.submenu_align.append(self.rightmenu)
		self.submenu_align.append(self.justifymenu)

		self.submenu_lists=gtk.Menu()
		self.submenu_lists.show()
		self.listsmenu=gtk.MenuItem("Lists")
		self.listsmenu.show()
		self.listsmenu.set_submenu(self.submenu_lists)

		self.ulmenu=gtk.MenuItem("Unordered")
		self.ulmenu.show()
		self.ulmenu.connect("activate",self.on_btnUnorderedList_clicked)

		self.olmenu=gtk.MenuItem("Ordered")
		self.olmenu.show()
		self.olmenu.connect("activate",self.on_btnOrderedList_clicked)

		self.limenu=gtk.MenuItem("List item")
		self.limenu.show()
		self.limenu.connect("activate",self.on_btnListItem_clicked)

		self.submenu_lists.append(self.ulmenu)
		self.submenu_lists.append(self.olmenu)
		self.submenu_lists.append(self.limenu)

		self.submenu_others=gtk.Menu()
		self.submenu_others.show()
		self.othersmenu=gtk.MenuItem("Others")
		self.othersmenu.show()
		self.othersmenu.set_submenu(self.submenu_others)

		self.linkmenu=gtk.MenuItem("Insert link")
		self.linkmenu.show()
		self.linkmenu.connect("activate",self.on_btnLink_clicked)

		self.imgmenu=gtk.MenuItem("Insert image")
		self.imgmenu.show()
		self.imgmenu.connect("activate",self.on_btnImage_clicked)

		self.pmenu=gtk.MenuItem("Paragraph")
		self.pmenu.show()
		self.pmenu.connect("activate",self.on_btnparag_clicked)

		self.moremenu=gtk.MenuItem("<!--more-->")
		self.moremenu.show()
		self.moremenu.connect("activate",self.on_btnMore_clicked)

		self.submenu_others.append(self.linkmenu)
		self.submenu_others.append(self.imgmenu)
		self.submenu_others.append(self.pmenu)
		self.submenu_others.append(self.moremenu)

		##Add elements to Tags menu
		self.submenu_tags.append(self.textmenu)
		self.submenu_tags.append(self.fontmenu)		
		self.submenu_tags.append(self.alignmenu)
		self.submenu_tags.append(self.listsmenu)
		self.submenu_tags.append(self.othersmenu)

#Submenu settings
		self.menu_settings=gtk.ImageMenuItem("Settings")
		settings_img = gtk.image_new_from_stock(gtk.STOCK_PREFERENCES, gtk.ICON_SIZE_MENU)
		self.menu_settings.set_image(settings_img)
		self.menu_settings.show()
		self.menu_settings.connect("activate",self.on_btnSettings_clicked)

#Submenu posting		
		self.submenu_posting=gtk.Menu()
		self.submenu_posting.show()
		self.menu_posting=gtk.MenuItem("Posting")
		self.menu_posting.show()
		self.menu_posting.set_submenu(self.submenu_posting)

		self.menu_categories=gtk.ImageMenuItem("Categories")
		categories_img = gtk.image_new_from_stock(gtk.STOCK_INDEX, gtk.ICON_SIZE_MENU)
		self.menu_categories.set_image(categories_img)
		self.menu_categories.show()
		self.menu_categories.connect("activate",self.on_btncategories_clicked)

		self.menu_post=gtk.ImageMenuItem("Post")
		post_img = gtk.image_new_from_stock(gtk.STOCK_GO_UP, gtk.ICON_SIZE_MENU)
		self.menu_post.set_image(post_img)
		self.menu_post.show()
		self.menu_post.connect("activate",self.on_btnpost_clicked)

		self.submenu_posting.append(self.menu_categories)
		self.submenu_posting.append(self.menu_post)

#Submenu about
		self.submenu_about=gtk.Menu()
		self.submenu_about.show()
		self.menu_about=gtk.MenuItem("About")
		self.menu_about.show()
		self.menu_about.set_submenu(self.submenu_about)

		self.menu_info=gtk.ImageMenuItem("Info")
		info_img = gtk.image_new_from_stock(gtk.STOCK_HELP, gtk.ICON_SIZE_MENU)
		self.menu_info.set_image(info_img)
		self.menu_info.show()
		self.menu_info.connect("activate",self.on_about_info, osso_hlp)

		self.menu_credits=gtk.ImageMenuItem("Credits")
		credits_img = gtk.image_new_from_stock(gtk.STOCK_ABOUT, gtk.ICON_SIZE_MENU)
		self.menu_credits.set_image(credits_img)
		self.menu_credits.show()
		self.menu_credits.connect("activate",self.on_about_credits)

		self.submenu_about.append(self.menu_info)
		self.submenu_about.append(self.menu_credits)

		self.menubar.append(self.menu_file)
		self.menubar.append(self.menu_edit)
		self.menubar.append(self.menu_tags)
		self.menubar.append(self.menu_settings)
		self.menubar.append(self.menu_posting)
		self.menubar.append(self.menu_about)
		self.menubar.append(self.menu_exit)

# Application main body
		self.notebook = gtk.Notebook()
		self.notebook.set_tab_pos(gtk.POS_TOP)
		self.notebook.set_scrollable(False)
		self.notebook.show()

		self.vbox1 = gtk.VBox(False, 0)
		self.vbox1.show()
		self.vbox1.set_spacing(0)

		self.hbox1 = gtk.HBox(False, 0)
		self.hbox1.show()
		self.hbox1.set_spacing(0)

		self.label1 = gtk.Label("Title:")
		self.label1.set_alignment(0, 0.5)
		self.label1.set_size_request(55, -1)
		self.label1.set_padding(0, 0)
		self.label1.show()
		self.hbox1.pack_start(self.label1, False, False, 0)

		self.enTitle = gtk.Entry()
		self.enTitle.set_text("")
		self.enTitle.set_editable(True)
		self.enTitle.show()
		self.enTitle.set_visibility(True)
		self.hbox1.pack_start(self.enTitle, True, True, 3)

		self.vbox1.pack_start(self.hbox1, False, True, 3)

		self.hbox2 = gtk.HBox(False, 0)
		self.hbox2.show()
		self.hbox2.set_spacing(0)

#		self.label2 = gtk.Label("Text:")
#		self.label2.set_alignment(0, 0.5)
#		self.label2.set_size_request(55, -1)
#		self.label2.set_padding(0, 0)
#		self.label2.show()
#		self.hbox2.pack_start(self.label2, False, False, 0)

		self.btnBold = gtk.Button()
		self.btnBold.set_focus_on_click(False)
		self.btnBold.show()
		self.btnBold.connect("clicked", self.on_btnBold_clicked)

		self.alignment1 = gtk.Alignment(0.5, 0.5, 0, 0)
		self.alignment1.show()

		self.hbox3 = gtk.HBox(False, 2)
		self.hbox3.show()
		self.hbox3.set_spacing(2)

		self.image1 = gtk.Image()
		self.image1.set_padding(0, 0)
		self.image1.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_text_bold.png")
		self.image1.show()
		self.hbox3.pack_start(self.image1, False, False, 0)

		self.alignment1.add(self.hbox3)
		self.btnBold.add(self.alignment1)

		self.hbox2.pack_start(self.btnBold, False, False, 0)

		self.btnItalic = gtk.Button()
		self.btnItalic.set_focus_on_click(False)
		self.btnItalic.show()
		self.btnItalic.connect("clicked", self.on_btnItalic_clicked)

		self.image2 = gtk.Image()
		self.image2.set_padding(0, 0)
		self.image2.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_text_italic.png")
		self.image2.show()
		self.btnItalic.add(self.image2)

		self.hbox2.pack_start(self.btnItalic, False, False, 0)

		self.btnLink = gtk.Button()
		self.btnLink.set_focus_on_click(False)
		self.btnLink.show()
		self.btnLink.connect("clicked", self.on_btnLink_clicked)

		self.image3 = gtk.Image()
		self.image3.set_padding(0, 0)
		self.image3.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_insert-url.png")
		self.image3.show()
		self.btnLink.add(self.image3)

		self.hbox2.pack_start(self.btnLink, False, False, 0)

		self.btnBlockQuote = gtk.Button()
		self.btnBlockQuote.set_focus_on_click(False)
		self.btnBlockQuote.show()
		self.btnBlockQuote.connect("clicked", self.on_btnBlockQuote_clicked)

		self.image4 = gtk.Image()
		self.image4.set_padding(0, 0)
		self.image4.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_draw-callouts.png")
		self.image4.show()
		self.btnBlockQuote.add(self.image4)

		self.hbox2.pack_start(self.btnBlockQuote, False, False, 0)

		self.btnDel = gtk.Button()
		self.btnDel.set_focus_on_click(False)
		self.btnDel.show()
		self.btnDel.connect("clicked", self.on_btnDel_clicked)

		self.image5 = gtk.Image()
		self.image5.set_padding(0, 0)
		self.image5.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_text-strikethrough.png")
		self.image5.show()
		self.btnDel.add(self.image5)

		self.hbox2.pack_start(self.btnDel, False, False, 0)

		self.btnIns = gtk.Button()
		self.btnIns.set_focus_on_click(False)
		self.btnIns.show()
		self.btnIns.connect("clicked", self.on_btnIns_clicked)

		self.image6 = gtk.Image()
		self.image6.set_padding(0, 0)
		self.image6.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_text_underlined.png")
		self.image6.show()
		self.btnIns.add(self.image6)

		self.hbox2.pack_start(self.btnIns, False, False, 0)

		self.btnImage = gtk.Button()
		self.btnImage.set_focus_on_click(False)
		self.btnImage.show()
		self.btnImage.connect("clicked", self.on_btnImage_clicked)

		self.image7 = gtk.Image()
		self.image7.set_padding(0, 0)
		self.image7.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_insert_image.png")
		self.image7.show()
		self.btnImage.add(self.image7)

		self.hbox2.pack_start(self.btnImage, False, False, 0)

		self.btnUnorderedList = gtk.Button()
		self.btnUnorderedList.set_focus_on_click(False)
		self.btnUnorderedList.show()
		self.btnUnorderedList.connect("clicked", self.on_btnUnorderedList_clicked)

		self.image8 = gtk.Image()
		self.image8.set_padding(0, 0)
		self.image8.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_list_bullet.png")
		self.image8.show()
		self.btnUnorderedList.add(self.image8)

		self.hbox2.pack_start(self.btnUnorderedList, False, False, 0)

		self.btnOrderedList = gtk.Button()
		self.btnOrderedList.set_focus_on_click(False)
		self.btnOrderedList.show()
		self.btnOrderedList.connect("clicked", self.on_btnOrderedList_clicked)

		self.image9 = gtk.Image()
		self.image9.set_padding(0, 0)
		self.image9.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_list_enum.png")
		self.image9.show()
		self.btnOrderedList.add(self.image9)

		self.hbox2.pack_start(self.btnOrderedList, False, False, 0)

		self.btnListItem = gtk.Button()
		self.btnListItem.set_focus_on_click(False)
		self.btnListItem.show()
		self.btnListItem.connect("clicked", self.on_btnListItem_clicked)

		self.image10 = gtk.Image()
		self.image10.set_padding(0, 0)
		self.image10.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_list-insert-unnumbered.png")
		self.image10.show()
		self.btnListItem.add(self.image10)

		self.hbox2.pack_start(self.btnListItem, False, False, 0)

		self.btnCode = gtk.Button()
		self.btnCode.set_focus_on_click(False)
		self.btnCode.show()
		self.btnCode.connect("clicked", self.on_btnCode_clicked)

		self.image11 = gtk.Image()
		self.image11.set_padding(0, 0)
		self.image11.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_script.png")
		self.image11.show()
		self.btnCode.add(self.image11)

		self.hbox2.pack_start(self.btnCode, False, False, 0)

		self.btnmoretags = gtk.Button()
		self.btnmoretags.set_focus_on_click(False)
		self.btnmoretags.show()
		self.btnmoretags.connect("clicked", self.on_optwrite_clicked)

		self.image12 = gtk.Image()
		self.image12.set_padding(0, 0)
		self.image12.set_from_stock(gtk.STOCK_ADD, 4)
		self.image12.show()
		self.btnmoretags.add(self.image12)

		self.hbox2.pack_start(self.btnmoretags, False, False, 0)

		self.vseparator1 = gtk.VSeparator()
		self.vseparator1.show()
		self.hbox2.pack_start(self.vseparator1, False, False, 0)

		self.vseparator2 = gtk.VSeparator()
		self.vseparator2.show()
		self.hbox2.pack_start(self.vseparator2, False, False, 0)

		self.btnSettings = gtk.Button()
		self.btnSettings.set_focus_on_click(False)
		self.btnSettings.show()
		self.btnSettings.connect("clicked", self.on_btnSettings_clicked)

		self.image13 = gtk.Image()
		self.image13.set_padding(0, 0)
		self.image13.set_from_stock(gtk.STOCK_PREFERENCES, 4)
		self.image13.show()
		self.btnSettings.add(self.image13)

		self.hbox2.pack_start(self.btnSettings, False, False, 0)

		self.btnCategories= gtk.Button()
		self.btnCategories.set_focus_on_click(False)
		self.btnCategories.show()
		self.btnCategories.connect("clicked", self.on_btncategories_clicked)

		self.image14 = gtk.Image()
		self.image14.set_padding(0, 0)
		self.image14.set_from_stock(gtk.STOCK_INDEX, 4)
		self.image14.show()
		self.btnCategories.add(self.image14)

		self.hbox2.pack_start(self.btnCategories, False, False, 0)

		self.btnPost = gtk.Button()
		self.btnPost.set_focus_on_click(False)
		self.btnPost.show()
		self.btnPost.connect("clicked", self.on_btnpost_clicked)

		self.image15 = gtk.Image()
		self.image15.set_padding(0, 0)
		self.image15.set_from_stock(gtk.STOCK_GO_UP, 4)
		self.image15.show()
		self.btnPost.add(self.image15)

		self.hbox2.pack_start(self.btnPost, False, False, 0)

		self.vbox1.pack_start(self.hbox2, False, True, 3)

		self.scrolledwindow2 = gtk.ScrolledWindow()
		self.scrolledwindow2.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.scrolledwindow2.show()
		self.scrolledwindow2.set_shadow_type(gtk.SHADOW_ETCHED_IN)

		self.txtPost = gtk.TextView()
		self.txtPost.set_wrap_mode(gtk.WRAP_WORD)
		self.txtPost.set_cursor_visible(True)
		self.txtPost.set_editable(True)
		self.txtPost.show()
		self.scrolledwindow2.add(self.txtPost)

		self.vbox1.pack_start(self.scrolledwindow2, True, True, 2)

		#Create page for others options for post
		self.vbox2 = gtk.VBox(False, 0)
		self.vbox2.show()
		self.vbox2.set_spacing(0)

		self.label_track = gtk.Label("Trackback URLs (separate with ;)")
		self.label_track.set_alignment(0, 0.5)
		self.label_track.set_padding(15, 15)
		self.label_track.show()

		self.en_track = gtk.Entry()
		self.en_track.set_editable(True)
		self.en_track.show()
		self.en_track.set_visibility(True)

		self.label_tags = gtk.Label("Technorati Tags")
		self.label_tags.set_alignment(0, 0.5)
		self.label_tags.set_padding(15, 15)
		self.label_tags.show()

		self.en_tags = gtk.Entry()
		self.en_tags.set_editable(True)
		self.en_tags.show()
		self.en_tags.set_visibility(True)

		self.comm_button = gtk.CheckButton('Allow Comments')
		self.comm_button.set_active(True)
		self.comm_button.show()

		self.pub_button = gtk.CheckButton('Publish')
		self.pub_button.set_active(True)
		self.pub_button.show()		

#		self.ping_button = gtk.CheckButton('Allow Pings')
#		self.ping_button.set_active(True)
#		self.ping_button.show()

		self.vbox2.pack_start(self.label_track, False, True, 2)
		self.vbox2.pack_start(self.en_track, False, False, 0)
		self.vbox2.pack_start(self.label_tags, False, True, 2)
		self.vbox2.pack_start(self.en_tags, False, False, 0)
		self.vbox2.pack_start(self.comm_button, False, False, 10)
		self.vbox2.pack_start(self.pub_button, False, False, 10)
#		self.vbox2.pack_start(self.ping_button, False, False, 0)

		#Create page for advanced posting
		self.vbox3 = gtk.VBox(False, 0)
		self.vbox3.show()
		self.vbox3.set_spacing(0)

		self.label_ext = gtk.Label("Extended entry:")
		self.label_ext.set_alignment(0, 0.5)
		self.label_ext.set_padding(4, 4)
		self.label_ext.show()

		self.scrolledwindow3 = gtk.ScrolledWindow()
		self.scrolledwindow3.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.scrolledwindow3.show()
		self.scrolledwindow3.set_shadow_type(gtk.SHADOW_ETCHED_IN)

		self.txtPostExt = gtk.TextView()
		self.txtPostExt.set_wrap_mode(gtk.WRAP_WORD)
		self.txtPostExt.set_cursor_visible(True)
		self.txtPostExt.set_editable(True)
		self.txtPostExt.show()
		self.scrolledwindow3.add(self.txtPostExt)

		self.label_exc = gtk.Label("Optional excerpt:")
		self.label_exc.set_alignment(0, 0.5)
		self.label_exc.set_padding(4, 4)
		self.label_exc.show()

		self.scrolledwindow4 = gtk.ScrolledWindow()
		self.scrolledwindow4.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
		self.scrolledwindow4.show()
		self.scrolledwindow4.set_shadow_type(gtk.SHADOW_ETCHED_IN)

		self.txtPostExc = gtk.TextView()
		self.txtPostExc.set_wrap_mode(gtk.WRAP_WORD)
		self.txtPostExc.set_cursor_visible(True)
		self.txtPostExc.set_editable(True)
		self.txtPostExc.show()
		self.scrolledwindow4.add(self.txtPostExc)

		self.vbox3.pack_start(self.label_ext, False, True, 2)
		self.vbox3.pack_start(self.scrolledwindow3, True, True, 0)
		self.vbox3.pack_start(self.label_exc, False, True, 2)
		self.vbox3.pack_start(self.scrolledwindow4, True, True, 0)

		#Get the buffer associated with the text views
		self.txtBuffer = self.txtPost.get_buffer()
		self.txtBufferExt = self.txtPostExt.get_buffer()
		self.txtBufferExc = self.txtPostExc.get_buffer()

		#Create page for Preview
#		self.vbox4 = gtk.VBox(False, 0)
#		self.vbox4.show()
#		self.vbox4.set_spacing(0)

#		self.htmlview = htmltextview.HtmlTextView()

#		def url_cb(view, url, type_):
#        print "url-clicked", url, type_

#		self.htmlview.connect("url-clicked", url_cb)

#		self.sw = gtk.ScrolledWindow()
#		self.sw.set_property("hscrollbar-policy", gtk.POLICY_AUTOMATIC)
#		self.sw.set_property("vscrollbar-policy", gtk.POLICY_AUTOMATIC)
#		self.sw.set_property("border-width", 0)
#		self.sw.add(self.htmlview)
#		self.sw.show()

#		self.frame = gtk.Frame()
#		self.frame.set_shadow_type(gtk.SHADOW_IN)
#		self.frame.show()
#		self.frame.add(self.sw)

#		self.vbox4.pack_start(self.frame, True, True, 0)

		#Add page1 to notebook
		self.page1 = gtk.Label("<small>Main Post</small>")
		self.page1.set_padding(0, 0)
		self.page1.set_use_markup(True)
		self.page1.show()

		self.notebook.append_page(self.vbox1, self.page1)

		#Add page2 to notebook
		self.page2 = gtk.Label("<small>Advanced Edit</small>")
		self.page2.set_padding(0, 0)
		self.page2.set_use_markup(True)
		self.page2.show()

		self.notebook.append_page(self.vbox3, self.page2)

		#Add page3 to notebook
		self.page3 = gtk.Label("<small>Others</small>")
		self.page3.set_padding(0, 0)
		self.page3.set_use_markup(True)
		self.page3.show()

		self.notebook.append_page(self.vbox2, self.page3)

		#Add page4 to notebook
#		self.page4 = gtk.Label("<small>Preview</small>")
#		self.page4.set_padding(0, 0)
#		self.page4.set_use_markup(True)
#		self.page4.show()

#		self.notebook.append_page(self.vbox4, self.page4)
#		self.notebook.connect("switch_page", self.html_view)
#		pagenum = self.notebook.get_current_page()

		self.wndMain.add(self.notebook)

#	def html_view(self, widget, dummy, pagenum):
#		if pagenum == 3:
#			iter_start = self.txtBuffer.get_start_iter()
#			iter_end = self.txtBuffer.get_end_iter()
#			text_main = self.txtBuffer.get_text(iter_start, iter_end, include_hidden_chars=1)

#			self.htmlview.delete_html()
#			self.htmlview.display_html("""
#    <body xmlns='http://www.w3.org/1999/xhtml'>
#        """ + text_main + """
#    </body>
#		""")
#			self.htmlview.show()
#		else: 'Error in HtmlView.'

	#Functions for fullscreen
	def on_window_state_change(self, widget, event, *args):           
		if event.new_window_state & gtk.gdk.WINDOW_STATE_FULLSCREEN:
			self.window_in_fullscreen = True
		else:
			self.window_in_fullscreen = False

	def on_key_press(self, widget, event, *args):            
		if event.keyval == gtk.keysyms.F6:
			if self.window_in_fullscreen:
				self.wndMain.unfullscreen ()
			else:
				self.wndMain.fullscreen ()

	def quit(self, widget):
		"""Quit yourself"""
		self.BlogSettings.save(self.dat_file)
		gtk.main_quit()

	def on_new_post(self, widget):		
		def on_cancel_clicked(widget):
			self.newpost_dlg.destroy()

		def on_ok_clicked(widget):
			self.enTitle.set_text("")
			self.en_tags.set_text("")
			self.en_track.set_text("")

			#Clear the Main Post
			buffer = self.txtPost.get_buffer()
			startiter = buffer.get_start_iter()
			enditer = buffer.get_end_iter()
			buffer.delete(startiter, enditer)
			#Clear the Extended Entry
			self.txtBufferExt.delete(self.txtBufferExt.get_start_iter(), self.txtBufferExt.get_end_iter())
			#Clear the Excerpt
			self.txtBufferExc.delete(self.txtBufferExc.get_start_iter(), self.txtBufferExc.get_end_iter())

			self.newpost_dlg.destroy()

		self.newpost_dlg = gtk.Dialog(title='Confirm New Post', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER)
		self.newpost_dlg.set_border_width(6)
		self.newpost_dlg.set_default_size(480, 120)

		self.vbox1 = gtk.VBox(False, 0)
		self.vbox1.show()
		self.vbox1.set_spacing(0)

		self.image_newpost = gtk.Image()
		self.image_newpost.set_padding(0, 0)
		self.image_newpost.set_from_stock(gtk.STOCK_DIALOG_WARNING, 6)
		self.image_newpost.show()
		self.vbox1.pack_start(self.image_newpost, True, True, 0)

		self.label_newpost = gtk.Label("Are you sure?\nThis will delete the current entry")
		self.label_newpost.set_padding(0, 0)
		self.label_newpost.show()
		self.vbox1.pack_start(self.label_newpost, False, False, 0)

		self.hbuttonbox = gtk.HButtonBox()
		self.hbuttonbox.show()
		self.hbuttonbox.set_spacing(0)
		self.hbuttonbox.set_layout(gtk.BUTTONBOX_DEFAULT_STYLE)

		self.cancel_newpost = gtk.Button()
		self.cancel_newpost.set_label("gtk-cancel")		
		self.cancel_newpost.set_use_stock(True)
		self.cancel_newpost.connect("clicked", on_cancel_clicked)
		self.cancel_newpost.show()

		self.hbuttonbox.pack_start(self.cancel_newpost)

		self.ok_newpost = gtk.Button()
		self.ok_newpost.set_label("gtk-ok")
		self.ok_newpost.set_use_stock(True)
		self.ok_newpost.connect("clicked", on_ok_clicked)
		self.ok_newpost.show()

		self.hbuttonbox.pack_start(self.ok_newpost)

		self.newpost_dlg.action_area.pack_start(self.hbuttonbox, False, False, 8)
		self.newpost_dlg.vbox.pack_start(self.vbox1, True, True, 0)
		
		self.newpost_dlg.show_all() 

	def on_open_post(self, widget):
		def openFile():
			self.file = self.open_dlg.get_filename()

			try:
				openFile = open(self.file, "r")
				title = cPickle.load(openFile)
				body = cPickle.load(openFile)
				tech_tags = cPickle.load(openFile)
				trackbacks = cPickle.load(openFile)
				extended_text = cPickle.load(openFile)
				excerpt_text = cPickle.load(openFile)

				self.enTitle.set_text(title)
				buffer = self.txtPost.get_buffer()
				buffer.set_text(body)
				self.en_tags.set_text(tech_tags)
				self.en_track.set_text(trackbacks)
				self.txtBufferExt.set_text(extended_text)
				self.txtBufferExc.set_text(excerpt_text)

			except:
				self.show_error_dlg("An error occurred in opening the file.")

		self.open_dlg = hildon.FileChooserDialog(self.wndMain, gtk.FILE_CHOOSER_ACTION_OPEN)
		self.open_dlg.set_title("Open Post")
		self.open_dlg.set_default_response(gtk.RESPONSE_OK)

		response = self.open_dlg.run()
		if response == gtk.RESPONSE_OK:
			openFile()
		self.open_dlg.destroy()

	def on_save_post(self, widget):
		def saveFile():
			self.file = self.save_dlg.get_filename()

			if os.path.isfile(self.file) == 1:
				self.overwrite_dlg = hildon.Note("confirmation", (self.save_dlg, "Are you sure? \nThis will overwrite the selected file.", gtk.STOCK_DIALOG_WARNING))
				self.overwrite_dlg.set_button_texts("Yes", "No")
				response = self.overwrite_dlg.run()
				if response == gtk.RESPONSE_OK:
					preWrite()
				else:
					self.overwrite_dlg.destroy()	
			else:
				writeFile()

		def preWrite():
			writeFile()
			self.overwrite_dlg.destroy()
			self.save_dlg.destroy()

		def writeFile():
			title = self.enTitle.get_text()
			buffer = self.txtPost.get_buffer()
			startiter = buffer.get_start_iter()
			enditer = buffer.get_end_iter()
			body = buffer.get_text(startiter, enditer, include_hidden_chars=1)
			tech_tags = self.en_tags.get_text()
			trackbacks = self.en_track.get_text()
			extended_text = self.txtBufferExt.get_text(self.txtBufferExt.get_start_iter(), self.txtBufferExt.get_end_iter(), include_hidden_chars=1)
			excerpt_text = 	self.txtBufferExc.get_text(self.txtBufferExc.get_start_iter(), self.txtBufferExc.get_end_iter(), include_hidden_chars=1)

			try:
				self.file = self.save_dlg.get_filename()
				saveFile = open(self.file, "w")
				cPickle.dump(title, saveFile)
				cPickle.dump(body, saveFile)
				cPickle.dump(tech_tags, saveFile)
				cPickle.dump(trackbacks, saveFile)
				cPickle.dump(extended_text, saveFile)
				cPickle.dump(excerpt_text, saveFile)
			except:
				self.show_error_dlg("An error occurred in saving the file.")
			try:
				self.save_dlg.destroy()
			except:
				pass
			saveFile.close()

		self.save_dlg = hildon.FileChooserDialog(self.wndMain, gtk.FILE_CHOOSER_ACTION_SAVE)
		self.save_dlg.set_title("Save Post")
		self.save_dlg.set_default_response(gtk.RESPONSE_OK)

		response = self.save_dlg.run()
		if response == gtk.RESPONSE_OK:
				saveFile()
		self.save_dlg.destroy()


	def on_cut(self, widget):

		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("cut-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("cut-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("cut-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("cut-clipboard")
		if self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("cut-clipboard")
		if self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("cut-clipboard")		
		else:
			pass

	def on_copy(self, widget):

		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("copy-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("copy-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("copy-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("copy-clipboard")
		if self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("copy-clipboard")
		if self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("copy-clipboard")		
		else:
			pass

	def on_paste(self, widget):

		if self.txtPost.is_focus() == 1:
			self.txtPost.emit("paste-clipboard")
		elif self.enTitle.is_focus() == 1:
			self.enTitle.emit("paste-clipboard")
		elif self.en_track.is_focus() == 1:
			self.en_track.emit("paste-clipboard")
		elif self.en_tags.is_focus() == 1:
			self.en_tags.emit("paste-clipboard")
		if self.txtPostExt.is_focus() == 1:
			self.txtPostExt.emit("paste-clipboard")
		if self.txtPostExc.is_focus() == 1:
			self.txtPostExc.emit("paste-clipboard")
		#lost focus for text here:
#		if self.enURL.is_focus() == 1:
#			self.enURL.emit("paste-clipboard")				
		else:
			pass

	def on_about_credits(self, widget):
		"""Show the credits dialog."""
		dialog = gtk.AboutDialog()
		dialog.set_name("Maemo WordPy")
		dialog.set_version("0.4")
		dialog.set_copyright("Copyleft © 2007")
		dialog.set_website("https://garage.maemo.org/projects/maemo-wordpy/")
		dialog.set_authors(["Daniel Martín Yerga <dyerga@gmail.com>"])
 		logo = gtk.gdk.pixbuf_new_from_file("/usr/share/maemo-wordpy/pixmaps/logo.png")
		dialog.set_logo(logo)
		dialog.set_license("This program is released under the GNU\nGeneral Public License. Please visit \nhttp://www.gnu.org/copyleft/gpl.html\nfor details.")
		dialog.run()
		dialog.destroy()

	def on_about_info(self, widget, osso_hlp):
		osso_hlp.show("help_maemowordpy_started", 1)

	def show_error_dlg(self, error_string):
		"""This Function is used to show an error dialog when
		an error occurs.
		error_string - The error string that will be displayed
		on the dialog.
		"""
		error_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, message_format=error_string, buttons=gtk.BUTTONS_OK)
		error_dlg.run()
		error_dlg.destroy()

	def on_btnBold_clicked(self, widget):
		"""Called when the bold button is clicked"""
		self.wrap_selection("<span style='font-weight: bold'>","</span>")

	def on_btnItalic_clicked(self, widget):
		"""Called when the italic button is clicked"""
		self.wrap_selection("<span style='font-style: italic'>","</span>")

	def on_btnLink_clicked(self, widget):
		"""Called when the link button is clicked"""
		def on_cancel_clicked(widget):
			self.link_dlg.destroy()

		def on_ok_clicked(widget):
			start, end = self.get_selection_iters()
			if ((start)and(end)):
				self.txtBuffer.select_range(end,start)
			self.wrap_selection("<a href=\"%s\">" % self.enURL.get_text(),"</a>")
			self.link_dlg.destroy()
			
		self.link_dlg = gtk.Dialog(title='Insert Link', parent=self.wndMain)
		self.link_dlg.set_border_width(6)
		self.link_dlg.set_default_size(480, 120)

		self.vbox1 = gtk.VBox(False, 0)
		self.vbox1.show()
		self.vbox1.set_spacing(0)

		self.label1 = gtk.Label("Enter the URL:")
		self.label1.set_padding(0, 0)
		self.label1.show()
		self.vbox1.pack_start(self.label1, False, False, 0)

		self.enURL = gtk.Entry()
		self.enURL.set_text("http://")
		self.enURL.select_region(7, 7)
		self.enURL.set_editable(True)
		self.enURL.show()
		self.enURL.set_visibility(True)
		self.vbox1.pack_start(self.enURL, False, False, 0)

		self.hbuttonbox = gtk.HButtonBox()
		self.hbuttonbox.show()
		self.hbuttonbox.set_spacing(0)
		self.hbuttonbox.set_layout(gtk.BUTTONBOX_DEFAULT_STYLE)

		self.cancelbutton = gtk.Button()
		self.cancelbutton.set_label("gtk-cancel")		
		self.cancelbutton.set_use_stock(True)
		self.cancelbutton.connect("clicked", on_cancel_clicked)
		self.cancelbutton.show()

		self.hbuttonbox.pack_start(self.cancelbutton)

		self.okbutton = gtk.Button()
		self.okbutton.set_label("gtk-ok")
		self.okbutton.set_use_stock(True)
		self.okbutton.connect("clicked", on_ok_clicked)
		self.okbutton.show()

		self.hbuttonbox.pack_start(self.okbutton)

		self.link_dlg.action_area.pack_start(self.hbuttonbox, False, False, 8)
		self.link_dlg.vbox.pack_start(self.vbox1, True, True, 0)
		
		self.link_dlg.show_all() 

	def on_btnBlockQuote_clicked(self, widget):
		"""Called when the Block Quote button is clicked"""		
		self.wrap_selection("<blockquote>","</blockquote>")

	def on_btnDel_clicked(self, widget):
		"""Called when the Del button is clicked"""
		today = datetime.date.today()
		self.wrap_selection('<span style="text-decoration:line-through">','</span>')

	def on_btnIns_clicked(self, widget):
		"""Called when the Ins button is clicked"""
		today = datetime.date.today()
		self.wrap_selection('<span style="text-decoration:underline">','</span>')

	def on_btnImage_clicked(self, widget):
		"""Called when the Image button is clicked"""

		def on_image_ok_clicked(widget):
			self.imageURL = self.en_imgsrc.get_text()
			self.imageAlt = self.en_alttext.get_text()
			self.imageAlign = self.img_align.get_active_text()
			self.imageHeight = str(self.img_width.get_value_as_int())
			self.imageWidth = str(self.img_height.get_value_as_int()) 

			if self.txtPost.is_focus() == 1:
				self.txtBuffer = self.txtPost.get_buffer()
			elif self.txtPostExt.is_focus() == 1:
				self.txtBuffer = self.txtPostExt.get_buffer()
			elif self.txtPostExc.is_focus() == 1:
				self.txtBuffer = self.txtPostExc.get_buffer()

			if self.imageURL.find("http://") >= 0:
				pass
			else: 
				#Try to get the wordpress client
				wp = self.BlogSettings.create_wordpress_client()
				if (wp == None):
					#Error creating Client, setting maybe wrong
					self.show_error_dlg("Error creating Worpress client, please check settings.")
					#Now get out of here
					return

				elif (self.imageURL!=""):
					try: #It will try upload an image file
						#Add interaction with conic library :)
						self.senal = True
						thread.start_new_thread(self.upload_img, (self.imageURL, wp))
						self.pgbar = ProgressBar("Uploading Image")

						#imageSrc = wp.newMediaObject(self.imageURL)
					except wordpresslib.WordPressException, e:
						self.pgbar.stop_pg()
						#wordpress lib error
						self.show_error_dlg(
						"Error uploading image:\nError code: %s\nError Message: %s"
						% (e.id, e.message))
					except xmlrpclib.Fault, e:
						self.pgbar.stop_pg()
						self.show_error_dlg(
						"Error uploading image:\nError code: %s\nError Message: %s"
						% (e.faultCode, e.faultString))
					except xmlrpclib.ProtocolError, e:
						self.pgbar.stop_pg()
						self.show_error_dlg(
						"Error uploading image:\nURL: %s\nError code: %s\nError Message: %s"
						% (e.url, e.errcode, e.errmsg))

			thread.start_new_thread(self.text_img, ())


		def on_image_cancel_clicked(widget):
			self.image_dlg.destroy()

		self.image_dlg = gtk.Dialog(title='Insert Image', parent=self.wndMain, flags=gtk.WIN_POS_NONE)

		self.image_dlg.set_border_width(5)
		self.image_dlg.set_property('has-separator', True)

		self.vbox2 = gtk.VBox(False, 2)
		self.vbox2.show()
		self.vbox2.set_spacing(2)

		self.hbox1 = gtk.HBox(False, 0)
		self.hbox1.show()
		self.hbox1.set_spacing(0)

		self.button1 = gtk.Button()
		self.button1.connect("clicked", self.browse_for_image)
		self.button1.set_label("Image:")
		self.button1.set_alignment(0.1, 0.5)
		self.button1.set_size_request(92, -1)
		self.button1.show()
		self.hbox1.pack_start(self.button1, False, False, 2)

		self.en_imgsrc = gtk.Entry()
		self.en_imgsrc.set_text("")
		self.en_imgsrc.set_editable(True)
		self.en_imgsrc.show()
		self.en_imgsrc.set_visibility(True)
		self.hbox1.pack_start(self.en_imgsrc, True, True, 0)

		self.vbox2.pack_start(self.hbox1, False, True, 0)

		self.hbox2 = gtk.HBox(False, 0)
		self.hbox2.show()
		self.hbox2.set_spacing(0)

		self.label2 = gtk.Label("Alt Text:")
		self.label2.set_alignment(0.1, 0.5)
		self.label2.set_size_request(96, -1)
		self.label2.set_padding(0, 0)
		self.label2.set_line_wrap(False)
		self.label2.show()
		self.hbox2.pack_start(self.label2, False, False, 0)

		self.en_alttext = gtk.Entry()
		self.en_alttext.set_text("")
		self.en_alttext.set_editable(True)
		self.en_alttext.show()
		self.en_alttext.set_visibility(True)
		self.hbox2.pack_start(self.en_alttext, True, True, 0)

		self.vbox2.pack_start(self.hbox2, False, True, 0)

		self.hseparator1 = gtk.HSeparator()
		self.hseparator1.show()
		self.vbox2.pack_start(self.hseparator1, True, True, 0)

		self.hbox3 = gtk.HBox(False, 0)
		self.hbox3.show()
		self.hbox3.set_spacing(0)

		self.hbox4 = gtk.HBox(False, 0)
		self.hbox4.set_size_request(250, -1)
		self.hbox4.show()
		self.hbox4.set_spacing(0)
		self.hbox4.set_border_width(2)

		self.label3 = gtk.Label("Align: ")
		self.label3.set_padding(0, 0)
		self.label3.set_line_wrap(False)
		self.label3.show()
		self.hbox4.pack_start(self.label3, False, False, 0)

		self.img_align_list = gtk.ListStore(gobject.TYPE_STRING)
		self.img_align = gtk.ComboBoxEntry(self.img_align_list, 0)
		self.img_align.set_size_request(128, -1)		
		self.img_align.show()	
		lista2 = ["left", "right", "center"]
		for item in lista2:
			self.img_align_list.append((item,))

		self.hbox4.pack_start(self.img_align, False, False, 0)

		self.hbox3.pack_start(self.hbox4, False, True, 0)

		self.vbox3 = gtk.VBox(False, 0)
		self.vbox3.show()
		self.vbox3.set_spacing(0)

		self.frame1 = gtk.Frame()
		self.frame1.set_size_request(300, -1)
		self.frame1.show()
		self.frame1.set_border_width(2)
		self.frame1.set_shadow_type(gtk.SHADOW_ETCHED_IN)

		self.vbox4 = gtk.VBox(False, 0)
		self.vbox4.show()
		self.vbox4.set_spacing(0)
		self.vbox4.set_border_width(6)

		self.hboxm = gtk.HBox()
		self.hboxm.show()

		self.original_button = gtk.RadioButton()
		self.original_button.set_label("Original")
		self.original_button.show()

		self.hboxm.pack_start(self.original_button, False, False, 0)

		self.resize_button = gtk.RadioButton(self.original_button)
		self.resize_button.set_active(False)
		self.resize_button.set_label("Resize")
		self.resize_button.show()

		self.hboxm.pack_start(self.resize_button, False, False, 0)

		self.vbox4.pack_start(self.hboxm, False, False, 0)

		self.hbox5 = gtk.HBox(False, 0)
		self.hbox5.show()
		self.hbox5.set_spacing(0)

		self.label4 = gtk.Label("Width:")
		self.label4.set_alignment(0.05, 0.5)
		self.label4.set_size_request(88, -1)
		self.label4.set_padding(0, 0)
		self.label4.set_line_wrap(False)
		self.label4.show()
		self.hbox5.pack_start(self.label4, False, False, 0)

		self.img_width = gtk.SpinButton(gtk.Adjustment(value=300, lower=0, upper=5000, step_incr=1, page_incr=10, page_size=10))
		self.img_width.show()
		self.img_width.set_digits(0)

		self.hbox5.pack_start(self.img_width, True, True, 0)

		self.vbox4.pack_start(self.hbox5, False, True, 3)

		self.hbox6 = gtk.HBox(False, 0)
		self.hbox6.show()
		self.hbox6.set_spacing(0)

		self.label5 = gtk.Label("Height:")
		self.label5.set_alignment(0.05, 0.5)
		self.label5.set_size_request(89, -1)
		self.label5.set_padding(0, 0)
		self.label5.set_line_wrap(False)
		self.label5.show()
		self.hbox6.pack_start(self.label5, False, False, 0)

		self.img_height = gtk.SpinButton(gtk.Adjustment(value=300, lower=0, upper=5000, step_incr=1, page_incr=10, page_size=10))
		self.img_height.show()
		self.img_height.set_digits(0)

		self.hbox6.pack_start(self.img_height, True, True, 0)

		self.vbox4.pack_start(self.hbox6, False, True, 4)

		self.frame1.add(self.vbox4)

		self.label6 = gtk.Label("Image Size")
		self.label6.set_padding(0, 0)
		self.label6.set_line_wrap(False)
		self.label6.show()
		self.frame1.set_label_widget(self.label6)

		self.vbox3.pack_start(self.frame1, True, True, 6)

		self.hbox3.pack_start(self.vbox3, True, True, 0)

		self.vbox2.pack_start(self.hbox3, False, True, 0)

		self.image_dlg.vbox.pack_start(self.vbox2, True, True, 0)

		self.hbuttonbox1 = gtk.HButtonBox()
		self.hbuttonbox1.show()
		self.hbuttonbox1.set_spacing(0)
		self.hbuttonbox1.set_layout(gtk.BUTTONBOX_END)

		self.image_cancel_button = gtk.Button(None, gtk.STOCK_CANCEL)
		self.image_cancel_button.connect("clicked", on_image_cancel_clicked)
		self.image_cancel_button.show()

		self.hbuttonbox1.pack_start(self.image_cancel_button)

		self.image_ok_button = gtk.Button(None, gtk.STOCK_OK)
		self.image_ok_button.show()
		self.image_ok_button.connect("clicked", on_image_ok_clicked)

		self.hbuttonbox1.pack_start(self.image_ok_button)

		self.image_dlg.action_area.pack_start(self.hbuttonbox1, True, True, 0)

		self.image_dlg.show()

	def upload_img(self, imgURL, wp):
		self.imageSrc = wp.newMediaObject(imgURL)
		if (self.imageSrc):
			self.imageURL = self.imageSrc
			self.pgbar.stop_pg()
			self.senal = False
		else:
			self.pgbar.stop_pg()
			self.show_error_dlg("Error uploading image")

	def text_img(self):
		self.image_dlg.destroy()
		while self.senal:
			time.sleep(0.5)
		img_src = "<img src=\"" + self.imageURL

		#If there is, get options for image (alt, align, etc)
		if self.imageURL == '':
			self.image_dlg.destroy()
			return
		if self.resize_button.get_active() == True:
			img_src = img_src + "\" width=\"" + self.imageWidth + "\" height=\"" + self.imageHeight
		if self.imageAlt != '':
			img_src = img_src + "\" alt=\"" + self.imageAlt
		#final_img_src is the final <img src...> text
		final_img_src = img_src + "\" />"

		if self.imageAlign != '':
			text1 = '<div style="text-align:' +  self.imageAlign + '">'
			self.txtBuffer.insert_at_cursor(text1, -1)
			start, end = self.txtBuffer.get_bounds()
			self.txtBuffer.insert_interactive(end, final_img_src, -1)
			text2 = '</div>'
			start, end = self.txtBuffer.get_bounds()			
			self.txtBuffer.insert_interactive(end, text2, -1)
		else:
			self.txtBuffer.insert_at_cursor(final_img_src, -1)
			
		self.image_dlg.destroy()

	def on_btnUnorderedList_clicked(self, widget):
		"""Called when the Unordered List button is clicked"""
		self.wrap_selection("<ul>","</ul>")

	def on_btnOrderedList_clicked(self, widget):
		"""Called when the Ordered List button is clicked"""
		self.wrap_selection("<ol>","</ol>")

	def on_btnListItem_clicked(self, widget):
		"""Called when the List Item button is clicked"""
		self.wrap_selection("<li>","</li>")

	def on_btnCode_clicked(self, widget):
		"""Called when the Code button is clicked"""
		self.wrap_selection("<code>","</code>")

	def on_optwrite_clicked(self, widget):
		"""Called when the MoreTags button is clicked"""
		self.optwrite_dlg = gtk.Dialog(title='More Tags', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
#		self.optwrite_dlg.set_size_request(220, 130)

		# first line buttons
		self.hbox1 = gtk.HBox()
		self.hbox1.set_spacing(8)

		self.btnleft = gtk.Button()
		self.btnleft.set_focus_on_click(False)
		self.btnleft.connect("clicked", self.on_btnleft_clicked)

		self.image17 = gtk.Image()
		self.image17.set_padding(0, 0)
		self.image17.set_from_stock(gtk.STOCK_JUSTIFY_LEFT, 4)
		self.btnleft.add(self.image17)

		self.btncenter = gtk.Button()
		self.btncenter.set_focus_on_click(False)
		self.btncenter.connect("clicked", self.on_btncenter_clicked)

		self.image18 = gtk.Image()
		self.image18.set_padding(0, 0)
		self.image18.set_from_stock(gtk.STOCK_JUSTIFY_CENTER, 4)
		self.btncenter.add(self.image18)

		self.btnright = gtk.Button()
		self.btnright.set_focus_on_click(False)
		self.btnright.connect("clicked", self.on_btnright_clicked)

		self.image19 = gtk.Image()
		self.image19.set_padding(0, 0)
		self.image19.set_from_stock(gtk.STOCK_JUSTIFY_RIGHT, 4)
		self.btnright.add(self.image19)

		self.hbox1.pack_start(self.btnleft, True, True, 0)
		self.hbox1.pack_start(self.btncenter, True, True, 0)
		self.hbox1.pack_start(self.btnright, True, True, 0)

		# second line buttons
		self.hbox2 = gtk.HBox()
		self.hbox2.set_spacing(8)

		self.btnjustify = gtk.Button()
		self.btnjustify.set_focus_on_click(False)
		self.btnjustify.connect("clicked", self.on_btnjustify_clicked)

		self.image20 = gtk.Image()
		self.image20.set_padding(0, 0)
		self.image20.set_from_stock(gtk.STOCK_JUSTIFY_FILL, 4)
		self.btnjustify.add(self.image20)

		self.btnMore = gtk.Button()
		self.btnMore.set_focus_on_click(False)
		self.btnMore.connect("clicked", self.on_btnMore_clicked)

		self.image16 = gtk.Image()
		self.image16.set_padding(0, 0)
		self.image16.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_insert-fields.png")
		self.btnMore.add(self.image16)

		self.btnparag = gtk.Button()
		self.btnparag.set_focus_on_click(False)
		self.btnparag.connect("clicked", self.on_btnparag_clicked)

		self.image21 = gtk.Image()
		self.image21.set_padding(0, 0)
		self.image21.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_para.png")
		self.btnparag.add(self.image21)

		self.hbox2.pack_start(self.btnjustify, True, True, 0)
		self.hbox2.pack_start(self.btnMore, True, True, 0)
		self.hbox2.pack_start(self.btnparag, True, True, 0)

		# third line buttons
		self.hbox3 = gtk.HBox()
		self.hbox3.set_spacing(8)

		self.btncolor_text = gtk.Button()
		self.btncolor_text.set_focus_on_click(False)
		self.btncolor_text.connect("clicked", self.on_text_color_clicked)

		self.image22 = gtk.Image()
		self.image22.set_padding(0, 0)
		self.image22.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_font_color.png")
		self.btncolor_text.add(self.image22)

		self.btnbg_color = gtk.Button()
		self.btnbg_color.set_focus_on_click(False)
		self.btnbg_color.connect("clicked", self.on_bg_color_clicked)

		self.image23 = gtk.Image()
		self.image23.set_padding(0, 0)
		self.image23.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_bg_color.png")
		self.btnbg_color.add(self.image23)

		self.btnfont_size = gtk.Button()
		self.btnfont_size.set_focus_on_click(False)
		self.btnfont_size.connect("clicked", self.on_size_font_clicked)

		self.image24 = gtk.Image()
		self.image24.set_padding(0, 0)
		self.image24.set_from_file("/usr/share/maemo-wordpy/pixmaps/stock_font_size.png")
		self.btnfont_size.add(self.image24)

		self.hbox3.pack_start(self.btncolor_text, True, True, 0)
		self.hbox3.pack_start(self.btnbg_color, True, True, 0)
		self.hbox3.pack_start(self.btnfont_size, True, True, 0)

		self.optwrite_dlg.vbox.pack_start(self.hbox1, False, False, 0)
		self.optwrite_dlg.vbox.pack_start(self.hbox2, False, False, 5)	
		self.optwrite_dlg.vbox.pack_start(self.hbox3, False, False, 5)	
	
		self.optwrite_dlg.show_all()
		self.optwrite_dlg.run()
		self.optwrite_dlg.destroy()


	def on_btnMore_clicked(self, widget):
		self.insert_text("<!--more-->")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnleft_clicked(self, widget):
		self.wrap_selection('<span style="text-align: left">', '</span>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btncenter_clicked(self, widget):
		self.wrap_selection('<span style="text-align: center">', '</span>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnright_clicked(self, widget):
		self.wrap_selection('<span style="text-align: right">', '</span>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnjustify_clicked(self, widget):
		self.wrap_selection('<span style="text-align: justify">', '</span>')
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_btnparag_clicked(self, widget):
		self.wrap_selection("<p>", "</p>")
		try:
			self.optwrite_dlg.destroy()
		except: pass

	def on_text_color_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		#run color selector dialog
		color_selector = hildon.ColorSelector(self.wndMain) 
		result = color_selector.run() 
		if (result==gtk.RESPONSE_OK):
			#get color selected
			text_color = color_selector.get_color() 
			#change color selected to a hex string
			colorstring = gtk.color_selection_palette_to_string([text_color])
			self.wrap_selection('<span style="color:' + colorstring + '">', '</span>')
		color_selector.destroy() 

	def on_bg_color_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		#run color selector dialog
		color_selector = hildon.ColorSelector(self.wndMain) 
		result = color_selector.run() 


		if (result==gtk.RESPONSE_OK):
			#get color selected
			bg_color = color_selector.get_color() 
			#change color selected to a hex string
			colorstring = gtk.color_selection_palette_to_string([bg_color])
			self.wrap_selection('<span style="background-color:' + colorstring + '">', '</span>')

		color_selector.destroy()

	def on_size_font_clicked(self, widget):
		try:
			self.optwrite_dlg.destroy()
		except: pass
		#run color selector dialog
		self.size_font_dlg = gtk.Dialog(title='Font Size', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
#		size_font_dlg.set_default_size(480, 150)

		self.font_size_list = gtk.ListStore(gobject.TYPE_STRING)
		self.font_size = gtk.ComboBoxEntry(self.font_size_list, 0)
#		self.font_size.set_size_request(128, -1)		
		list_font_size = ["xx-small", "x-small", "small", "medium", "large", "x-large", "xx-large"]
		for item in list_font_size:
			self.font_size_list.append((item,))

		self.size_font_dlg.vbox.pack_start(self.font_size, False, False, 0)
		self.size_font_dlg.show_all()

		result = self.size_font_dlg.run() 
		if (result==gtk.RESPONSE_OK):
			fontsize = self.font_size.get_active_text()
			self.wrap_selection('<span style="font-size:' + fontsize + '">', '</span>')

		self.size_font_dlg.destroy() 

	def on_btnSettings_clicked(self, widget):
		"""Called when the settings button is clicked.  It will
		show the dlgSettings dialog and let the user set the WordPress
		blog settings."""

		result = gtk.RESPONSE_CANCEL		
	
		self.settings_dlg = gtk.Dialog(title='Settings', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))
		self.settings_dlg.set_border_width(6)
		self.settings_dlg.set_default_size(480, 150)

		self.table1 = gtk.Table()
		self.table1.show()
		self.table1.set_row_spacings(0)
		self.table1.set_col_spacings(0)

		self.label1 = gtk.Label("URL:")
		self.label1.set_alignment(0, 0.5)
		self.label1.set_padding(0, 0)
		self.label1.show()
		self.table1.attach(self.label1, 0, 1, 0, 1, gtk.FILL, 0, 0, 0)

		self.label2 = gtk.Label("Username:")
		self.label2.set_alignment(0, 0.5)
		self.label2.set_padding(0, 0)
		self.label2.show()
		self.table1.attach(self.label2, 0, 1, 1, 2, gtk.FILL, 0, 0, 0)

		self.label3 = gtk.Label("Password")
		self.label3.set_alignment(0, 0.5)
		self.label3.set_padding(0, 0)
		self.label3.show()
		self.table1.attach(self.label3, 0, 1, 2, 3, gtk.FILL, 0, 0, 0)

		self.enURL = gtk.Entry()
		self.enURL.set_text(self.BlogSettings.URL)
		self.enURL.set_editable(True)
		self.enURL.show()
		self.enURL.set_visibility(True)
		self.table1.attach(self.enURL, 1, 2, 0, 1, gtk.EXPAND|gtk.FILL, 0, 0, 0)

		self.enUsername = gtk.Entry()
		self.enUsername.set_text(self.BlogSettings.Username)
		self.enUsername.set_editable(True)
		self.enUsername.show()
		self.enUsername.set_visibility(True)
		self.table1.attach(self.enUsername, 1, 2, 1, 2, gtk.EXPAND|gtk.FILL, 0, 0, 0)

		self.enPassword = gtk.Entry()
		self.enPassword.set_text(self.BlogSettings.Password)
		self.enPassword.set_editable(True)
		self.enPassword.show()
		self.enPassword.set_visibility(False)
		self.enPassword.set_invisible_char('*')
		self.table1.attach(self.enPassword, 1, 2, 2, 3, gtk.EXPAND|gtk.FILL, 0, 0, 0)

		self.settings_dlg.vbox.pack_start(self.table1, True, True, 0)
		
		self.settings_dlg.show_all()

		result = self.settings_dlg.run()
		if (result==gtk.RESPONSE_OK):
			#get the value of the entry fields
			self.BlogSettings.URL = self.enURL.get_text()
			self.BlogSettings.Username = self.enUsername.get_text()
			self.BlogSettings.Password = self.enPassword.get_text()

		#we are done with the dialog, destroy it
		self.settings_dlg.destroy()

		#return the result
		return result

	def on_btncategories_clicked(self, widget):
		result = gtk.RESPONSE_CANCEL

        # create dialog, etc		
		self.category_dlg = gtk.Dialog(title='Categories', parent=None, flags=gtk.DIALOG_MODAL | gtk.WIN_POS_CENTER, buttons=(gtk.STOCK_OK, gtk.RESPONSE_OK, gtk.STOCK_CANCEL, gtk.RESPONSE_CANCEL))

		self.category_dlg.set_border_width(8)
		self.category_dlg.set_default_size(300, 250)

		vbox1 = gtk.VBox(False, 8)

		label = gtk.Label('Categories')
		vbox1.pack_start(label, False, False)

		sw = gtk.ScrolledWindow()
		sw.set_shadow_type(gtk.SHADOW_ETCHED_IN)
		sw.set_policy(gtk.POLICY_NEVER, gtk.POLICY_AUTOMATIC)
		vbox1.pack_start(sw)

		# clear categories chosen before
		del cats[:]
		del data[:]
		self.GetCategoryList()

		if data == []:
			return
		model = self.__create_model()

        # create tree view
		treeview = gtk.TreeView(model)
		treeview.set_rules_hint(True)
		treeview.set_property("allow-checkbox-mode", False)
		treeview.set_search_column(COLUMN_DESCRIPTION)

		sw.add(treeview)

        # add columns to the tree view
		self.__add_columns(treeview)

		self.category_dlg.vbox.pack_start(vbox1, True, True, 0)
		self.category_dlg.show_all()

		result = self.category_dlg.run()
		if (result==gtk.RESPONSE_OK):
			## This is for debug
			cats2 = cats
#			print 'categories added: ', cats2

		#we are done with the dialog, destroy it
		self.category_dlg.destroy()

		#return the result
		return result

	def GetCategoryList(self):
		#Try to get the wordpress client
		try:
			wp = self.BlogSettings.create_wordpress_client()
			#Select blog. TODO: choose if there is more than one blog
			wp.selectBlog(0)
			categories = tuple(wp.getCategoryList())
			#Save category list in [data]
			for i in categories:
				a = False
				b = i.name
				c = (a, b)
				data.append(c)
			return data
		except: 
			self.show_error_dlg("Error creating Worpress client, please check settings.")


	def __create_model(self):
		lstore = gtk.ListStore(gobject.TYPE_BOOLEAN, gobject.TYPE_STRING)
		#Added the category list to lstore
		for item in data:
			iter = lstore.append()
			lstore.set(iter, COLUMN_FIXED, item[COLUMN_FIXED], COLUMN_DESCRIPTION, item[COLUMN_DESCRIPTION])
		return lstore

	def fixed_toggled(self, cell, path, model):
        # get toggled iter
		iter = model.get_iter((int(path),))
		fixed = model.get_value(iter, COLUMN_FIXED)
        # do something with the value
		fixed = not fixed
        # set new value
		model.set(iter, COLUMN_FIXED, fixed)

		#If togglebutton is choose, add category name
		#to [cats]
		if fixed == True:
			a = model.get_value(iter, COLUMN_DESCRIPTION)
			cats.append(a)
		#If togglebutton is choose and delete,
		#delete category name from [cats]
		elif fixed == False:
			b = model.get_value(iter, COLUMN_DESCRIPTION)
#			print 'delete cat: ', b
			numero = cats.index(b)
#			print 'cat index: ', numero
			del cats[numero]

	def __add_columns(self, treeview):
		model = treeview.get_model()

        # column for fixed toggles
		renderer = gtk.CellRendererToggle()
		renderer.connect('toggled', self.fixed_toggled, model)

		column = gtk.TreeViewColumn('Fixed', renderer, active=COLUMN_FIXED)
        # set this column to a fixed sizing(of 50 pixels)
		column.set_sizing(gtk.TREE_VIEW_COLUMN_FIXED)
		column.set_fixed_width(50)
		treeview.append_column(column)

        # column for description
		column = gtk.TreeViewColumn('Description', gtk.CellRendererText(), text=COLUMN_DESCRIPTION)
		treeview.append_column(column)

	def technorati_tags(self):
		"""Get the technorati tags."""
		#Get tags from text entry
		tags = self.en_tags.get_text()
		#Separate the tags in a list
		tagsArray = []
		for item in tags.split(";"):
			tagsArray.append(item)
		#Create the technorati tag model
		lista = []
		for tag in tagsArray:
			llave = '<a href="http://technorati.com/tag/' + tag + '" rel="tag">' + tag + '</a>'
			lista.append(llave)
		#Separate each link
		self.texto_technorati = (', ').join(lista)


	def on_btnpost_clicked(self, widget):
		#Try to get the wordpress client
		wp = self.BlogSettings.create_wordpress_client()
		if (wp == None):
			#Error creating Client, setting maybe wrong
			self.show_error_dlg("Error creating Worpress client, please check settings.")
			#Now get out of here
			return

		try:
			self.posting = True
			thread.start_new_thread(self.trat_post, (wp,))
			self.pgbar = ProgressBar("Posting")
		except:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing post.",))


		thread.start_new_thread(self.upload_post, (wp,))

	def trat_post(self, wp):
		self.post = wordpresslib.WordPressPost()

		# Allow Pings
#		if self.ping_button.get_active() == True:
#			post.allowPings = '1'
#		else:
#			post.allowPings = '0'

		# Allow Comments
		if self.comm_button.get_active() == True:
			self.post.allowComments = True
		else:
			self.post.allowComments = 'False'

		#Title
		self.post.title = self.enTitle.get_text()
		#Text
		start, end = self.txtBuffer.get_bounds()
		texto_post = self.txtBuffer.get_text(start, end)
		#Execute technorati tags
		self.technorati_tags()
		#If there aren't tags 
		if self.texto_technorati == '<a href="http://technorati.com/tag/" rel="tag"></a>':
			nuevo_texto = texto_post
		#If there are tags add the links to main post
		else: 
			nuevo_texto = texto_post + '<br /><br />' + '<small>Technorati Tags: ' + self.texto_technorati + '</small><br />'

		self.post.description = nuevo_texto
		#TextMore
		start, end = self.txtBufferExt.get_bounds()
		self.post.textMore = self.txtBufferExt.get_text(start, end)
		#Excerpt
		start, end = self.txtBufferExc.get_bounds()
		self.post.excerpt = self.txtBufferExc.get_text(start, end)
		#Trackbacks 
		trackbackArray = []
		trackbackURLS = self.en_track.get_text()
		for item in trackbackURLS.split(";"):
			trackbackArray.append(item)

		self.post.trackbacks=trackbackArray
		#Categories
		for i in range(len(cats)):
			mj = wp.getCategoryIdFromName(cats[i])
			idfromcat.append(mj) 

		self.post.categories = idfromcat

		# Get publish/draft post
		if self.pub_button.get_active() == True:
			self.publish = True
		elif self.pub_button.get_active() == False:
			self.publish = False

		self.posting = False

	def upload_post(self, wp):
		"""Called when the post button is clicked, this will
		post the post to the blog."""
		while self.posting:
			time.sleep(0.5)

		#Now post the post!
		try:
			new_post_id = wp.newPost(self.post, self.publish)
			self.pgbar.stop_pg()
			thread.start_new_thread(self.success_dlg, ("Success! Post has been published!", ))
		except xmlrpclib.Fault, e:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing post:\nError code: %s\nError Message: %s" % (e.faultCode, e.faultString),))
		except xmlrpclib.ProtocolError, e:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing post:\nURL: %s\nError code: %s\nError Message: %s" % (e.url, e.errcode, e.errmsg),))
		except:
			self.pgbar.stop_pg()
			thread.start_new_thread(self.error_post, ("Error publishing post.",))

	def success_dlg(self, msg):
		success_dlg = gtk.MessageDialog(type=gtk.MESSAGE_INFO, message_format=msg, buttons=gtk.BUTTONS_CLOSE)
		gtk.gdk.threads_enter()
		success_dlg.run()
		gtk.gdk.threads_leave()
		success_dlg.destroy()
		return True

	def error_post(self, msg):
		error_post_dlg = gtk.MessageDialog(type=gtk.MESSAGE_ERROR, message_format=msg, buttons=gtk.BUTTONS_CLOSE)
		gtk.gdk.threads_enter()
		error_post_dlg.run()
		gtk.gdk.threads_leave()
		error_post_dlg.destroy()
		return True


	def browse_for_image(self, widget):
		"""This function is used to browse for an image.
		The path to the image will be returned if the user
		selects one, however a blank string will be returned
		if they cancel or do not select one."""
		self.fileopen_dlg = hildon.FileChooserDialog(self.wndMain, gtk.FILE_CHOOSER_ACTION_OPEN)
		self.fileopen_dlg.set_title("Browse Image")
		self.fileopen_dlg.set_default_response(gtk.RESPONSE_OK)
		"""Init the return value"""
		result = ""
		if self.fileopen_dlg.run() == gtk.RESPONSE_OK:
			result = self.fileopen_dlg.get_filename()
		self.fileopen_dlg.destroy()

		self.en_imgsrc.set_text(result)

		return result

	def get_selection_iters(self):
		"""This function gets the start and end selection
		iters from the text view.  If there is no selection
		the current position of the cursor will be returned.
		Returns - start,end - gtk.TextIter objects"""

		#init
		start = None
		end = None

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		#First check to see that the text buffer is valid
		if (not self.txtBuffer):
			self.show_error_dlg("Text buffer not available")
			return start,end

		#Get the selection bounds
		bounds = self.txtBuffer.get_selection_bounds();
		if (bounds):
			#If there is a selection we are done
			start,end = bounds
		else:
			#There is no selection so just get the cursor mark
			cursor_mark = self.txtBuffer.get_insert()
			"""Set start and end to be gtk.TextIter objercts at the
			position of the cursor mark"""
			start = self.txtBuffer.get_iter_at_mark(cursor_mark)
			end = self.txtBuffer.get_iter_at_mark(cursor_mark)

		return start, end

	def insert_text(self, text):
		"""This function inserts text into the text buffer
		self.txtBuffer at the current selection.  If text is
		selected it will be overwritten, otherwise it will simply be
		inserted at the cursor position
		text - The text to be inserted in the buffer
		"""

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		start, end = self.get_selection_iters();

		if ((not start)or(not end)):
			self.show_error_dlg("Error inserting text")
			return;

		#Delete the selected text (start and end will be equal after)
		self.txtBuffer.delete(start,end)
		#Save a mark at the start position since after we insert
		#the text start will be invalid
		start_mark = self.txtBuffer.create_mark(None, start, True)
		#Insert, end will be set to the end insert position
		self.txtBuffer.insert(end,text)
		start = self.txtBuffer.get_iter_at_mark(start_mark)
		#select the text, use end as the first param so that
		#it will be the cursor position
		self.txtBuffer.select_range(end,start)
		#delete the start mark
		self.txtBuffer.delete_mark(start_mark)

	def wrap_selection(self, start_tag, end_tag):
		"""This fucntion is used to wrap the currently selected
		text in the gtk.TextView with start_tag and end_tag. If
		there is no selection start_tag and end_tag will be
		inserted at the cursor position
		start_tag - The text that will go at the start of the
		selection.
		end_tag - The text that will go at the end of the
		selection."""

		if self.txtPost.is_focus() == 1:
			self.txtBuffer = self.txtPost.get_buffer()
		elif self.txtPostExt.is_focus() == 1:
			self.txtBuffer = self.txtPostExt.get_buffer()
		elif self.txtPostExc.is_focus() == 1:
			self.txtBuffer = self.txtPostExc.get_buffer()

		start, end = self.get_selection_iters();
		if ((not start)or(not end)):
			self.show_error_dlg("Error inserting text")
			return;
		#Create a mark at the start and end
		start_mark = self.txtBuffer.create_mark(None,start, True)
		end_mark = self.txtBuffer.create_mark(None, end, False)
		#Insert the start_tag
		self.txtBuffer.insert(start, start_tag)
		#Get the end iter again
		end = self.txtBuffer.get_iter_at_mark(end_mark)
		#Insert the end tag
		self.txtBuffer.insert(end, end_tag)
		#Get the start and end iters
		start = self.txtBuffer.get_iter_at_mark(start_mark)
		end = self.txtBuffer.get_iter_at_mark(end_mark)
		#Select the text
		self.txtBuffer.select_range(end,start)
		#Delete the gtk.TextMark objects
		self.txtBuffer.delete_mark(start_mark)
		self.txtBuffer.delete_mark(end_mark)


class WordPressBlogSettings:
	"""This class holds the necessary wordpress blog settings
	URL - The URL of the blog
	Username - The username posting
	Password - The password for the username
	"""
	def __init__(self, File="", URL="", Username="", Password=""):
		self.URL = URL
		self.Username = Username
		self.Password = Password
		if (File != ""):
			# Load from file
			try:
				file = open(File, 'rb')
				self.URL = cPickle.load(file)
				self.Username = cPickle.load(file)
				self.Password = cPickle.load(file)
				dec_pass=base64.decodestring(self.Password)
				self.Password=dec_pass
				file.close()
			except:
				return

	def save(self, File):
		"""cPickle the information into the file"""
		try:
			save_file = open(File, 'wb')
			cPickle.dump(self.URL, save_file)
			cPickle.dump(self.Username, save_file)
			enc_pass=base64.encodestring(self.Password)
			self.Password=enc_pass
			cPickle.dump(self.Password, save_file)
			save_file.close()
		except:
			print "Error saving blog settings."

	def create_wordpress_client(self):
		"""Quick helper routine used to create the wordpress
		client"""
		# prepare client object
		try:
			wp = wordpresslib.WordPressClient(self.URL, self.Username, self.Password)
		except:
			return None

		# select blog id
		wp.selectBlog(0)

		return wp


class ProgressBar:
	def __init__(self, pg_text):
		self.w = gtk.Dialog("Progressbar", None)
		vbox = gtk.VBox(False, 5)
		self.progress = gtk.ProgressBar()
		self.progress.set_size_request(250,-1)
		self.progress.set_text(pg_text)
		vbox.add(self.progress)
		self.w.vbox.add(vbox)
		self.w.show_all()

		self.active = True
		self.progress.pulse()
		self.timeout_cb = gobject.timeout_add(200, self.increment)

	def stop_pg(self):
		self.active = False
		self.w.destroy()

	def increment(self):        
		if not self.active:
            # we were disabled, so stop pulsating
			return False
		self.progress.pulse()
		return True

if __name__ == "__main__":
	Wordpy()
	gtk.gdk.threads_enter()
	gtk.main()
	gtk.gdk.threads_leave()
